// Track5BX Copyright © 2007 Tyler C. Sarna
// All Rights Reserved. No Warrantee.

// $Id: Track5BX.js,v 1.5 2007/12/29 03:40:51 tsarna Exp $

version = 100; // 1.0.0

data = {
    1  : {bends : 2,  situps : 3,  leglifts : 4,  pushups : 2,  steps : 105},
    2  : {bends : 3,  situps : 4,  leglifts : 5,  pushups : 3,  steps : 140},
    3  : {bends : 4,  situps : 6,  leglifts : 6,  pushups : 3,  steps : 170},
    4  : {bends : 6,  situps : 7,  leglifts : 8,  pushups : 4,  steps : 200},
    5  : {bends : 7,  situps : 9,  leglifts : 9,  pushups : 5,  steps : 225},     
    6  : {bends : 8,  situps : 10, leglifts : 10, pushups : 6,  steps : 255},   
    7  : {bends : 10, situps : 11, leglifts : 12, pushups : 7,  steps : 280},  
    8  : {bends : 12, situps : 13, leglifts : 14, pushups : 8,  steps : 305},  
    9  : {bends : 14, situps : 15, leglifts : 16, pushups : 9,  steps : 325},  
    10 : {bends : 16, situps : 16, leglifts : 18, pushups : 11, steps : 350},
    11 : {bends : 18, situps : 18, leglifts : 20, pushups : 12, steps : 370},
    12 : {bends : 20, situps : 20, leglifts : 22, pushups : 13, steps : 390},
    13 : {bends : 23, situps : 21, leglifts : 25, pushups : 15, steps : 405},
    14 : {bends : 25, situps : 23, leglifts : 27, pushups : 16, steps : 425},
    15 : {bends : 28, situps : 25, leglifts : 30, pushups : 18, steps : 440},
    16 : {bends : 14, situps : 10, leglifts : 12, pushups : 9,  steps : 340}, 
    17 : {bends : 15, situps : 11, leglifts : 14, pushups : 10, steps : 355},
    18 : {bends : 16, situps : 12, leglifts : 16, pushups : 11, steps : 375},
    19 : {bends : 18, situps : 13, leglifts : 17, pushups : 12, steps : 390},
    20 : {bends : 19, situps : 14, leglifts : 19, pushups : 13, steps : 405},
    21 : {bends : 21, situps : 15, leglifts : 21, pushups : 14, steps : 420},
    22 : {bends : 22, situps : 16, leglifts : 23, pushups : 15, steps : 435},
    23 : {bends : 24, situps : 17, leglifts : 25, pushups : 16, steps : 445},
    24 : {bends : 25, situps : 18, leglifts : 27, pushups : 17, steps : 460},
    25 : {bends : 27, situps : 20, leglifts : 29, pushups : 18, steps : 470},
    26 : {bends : 29, situps : 21, leglifts : 31, pushups : 19, steps : 480},
    27 : {bends : 31, situps : 23, leglifts : 33, pushups : 20, steps : 490},
    28 : {bends : 33, situps : 24, leglifts : 36, pushups : 21, steps : 500},
    29 : {bends : 34, situps : 26, leglifts : 38, pushups : 22, steps : 510},
    30 : {bends : 36, situps : 28, leglifts : 40, pushups : 23, steps : 515},
    31 : {bends : 38, situps : 29, leglifts : 43, pushups : 24, steps : 525},
    32 : {bends : 40, situps : 31, leglifts : 45, pushups : 25, steps : 530},
    33 : {bends : 43, situps : 33, leglifts : 48, pushups : 26, steps : 535},
    34 : {bends : 45, situps : 35, leglifts : 51, pushups : 27, steps : 540},
    35 : {bends : 47, situps : 37, leglifts : 54, pushups : 28, steps : 540},
    36 : {bends : 49, situps : 39, leglifts : 56, pushups : 29, steps : 545},
    37 : {bends : 51, situps : 41, leglifts : 59, pushups : 30, steps : 545},
    38 : {bends : 54, situps : 43, leglifts : 62, pushups : 31, steps : 545},
    39 : {bends : 56, situps : 46, leglifts : 65, pushups : 32, steps : 550},
    40 : {bends : 59, situps : 48, leglifts : 68, pushups : 33, steps : 555},
    41 : {bends : 61, situps : 50, leglifts : 72, pushups : 34, steps : 555},
    42 : {bends : 64, situps : 53, leglifts : 75, pushups : 35, steps : 555},
    43 : {bends : 66, situps : 55, leglifts : 78, pushups : 36, steps : 560},
    44 : {bends : 69, situps : 58, leglifts : 81, pushups : 37, steps : 560},
    45 : {bends : 72, situps : 61, leglifts : 85, pushups : 38, steps : 560},
    46 : {bends : 74, situps : 64, leglifts : 88, pushups : 39, steps : 575},
    47 : {bends : 77, situps : 66, leglifts : 92, pushups : 40, steps : 575},
    48 : {bends : 80, situps : 69, leglifts : 96, pushups : 41, steps : 575},

	maxrung : 48
}

urls = {
	wname : "http://ty.sarna.org/sw/widgets/track5bx/index.html",
	tysarna : "http://ty.sarna.org/",
	vercheck: "http://feeds.feedburner.com/track5bx-version",
}

titles = {
	bends_intro: "Stand upright with your legs apart, hands outstretched above your head. Bend forward, as far as you can, trying to touch your toes. Straighten up and bend backward moderately. Repeat the specified number of times.",
	situps_intro: "Lie on your back, feet slightly apart, hands at your side. Lift your head and shoulders off the floor far enough so that you can see your heels. Smoothly lower your head and shoulders back to the floor. Repeat the specified number of times.",
	leglifts_intro: "Lie face down, legs slightly apart, with the palms of your hands under your thighs. Lift your left leg, bending at the hip and knee, while simultaneously lifting your head from the floor. Smoothly lower both your head and leg. Then lift your right leg and head in the same manner. Repeat the specified number of times (each repetition involves lifting both the left and right legs).",
	pushups_intro: "Lie face down on the floor with palms just outside your shoulders and arms bent. Keeping your knees on the floor and allowing your legs to bend at the knee but holding your upper body straight, lift your body until your arms are straight. Then smoothly lower your body back to the floor. Repeat the specified number of times.",
	steps_intro: "Run in place at a brisk pace for the specified number of steps, lifting your legs 4 to 6 inches from the floor with each step. Every set of 75 steps, stop and do 7 introductory ``jumping jacks'': stand with your legs together, arms at your side. Jump up in the air, extending your legs to the side and your arms outward to the level of your shoulders. Then jump up again, bringing your legs back together and your arms back to your side. Be sure to count a running step only as your left foot touches the floor, not every time either foot touches.",
	bends_lifetime: "Stand upright with your legs apart, hands outstretched above your head. Bend forward and touch the floor between your legs, bounce up a few inches, and touch the floor again. Then straighten up and bend backward. Repeat the specified number of times.",
	situps_lifetime: "Lie on your back, feet slightly apart, hands at your side. Lift your upper body, bending at the waist, until you're sitting up vertically. Keep your arms at your sides and your feet on the floor--avoid the temptation to ``cheat'' by pulling yourself up with your arms or levering yourself up by raising your legs. Smoothly lower your body back to the floor. Repeat the specified number of times.",
	leglifts_lifetime: "Lie face down, legs slightly apart, with the palms of your hands under your thighs. Lift both legs, bending at the hip, at least high enough that your thighs are lifted from your hands. Simultaneously lift your head and shoulders from the floor. Smoothly lower your head, shoulders, and both legs. Repeat the specified number of times.",
	pushups_lifetime: "Lie face down with palms just outside your shoulders and arms bent. Keeping your back straight, pivoting on your toes, lift your body until your arms are straight. Then smoothly lower your body back to the floor, touching your chest. Repeat the specified number of times.",
	steps_lifetime: "Run in place at a brisk pace for the specified number of steps, lifting your legs 4 to 6 inches from the floor with each step. Every set of 75 steps, stop and do 10 ``jumping jacks'': stand with your legs together, arms at your side. Jump up in the air, extending your legs to the side and your arms upward as high as you can (ideally touching your fingers together above your head). Then jump up again, bringing your legs back together and your arms back to your side. Be sure to count a step in running only as your left foot touches the floor, not every time either foot touches.",
}

function $(key)
{
	return document.getElementById(key);
}

function getPref(key)
{
	return widget.preferenceForKey(/*widget.identifier + "-" + */ key);
}

function setPref(key, val)
{
	return widget.setPreferenceForKey(val, /* widget.identifier + "-" + */ key);
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	loadPrefs();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    /*
	setPref("rung", null);

	for (var i = 1; i <= data.maxrung; i++) {
		setPref("reps-" + i, null);
	}
	*/
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	maybeCheckVersion();
}


function loadPrefs()
{
	rung = getPref("rung");
	if (!rung) {
		alert(rung);
		rung = 1;
	}

	reps = getPref("reps-" + rung);
	if (!reps) {
		reps = 0;
	}

	rungdelta(0);
	repdelta(0);
}

function setTitle(item)
{
	var k = item;
	
	if (k == "sets") {
		k = "steps";
	}
	
	if (rung >= 16) {
		k = k + "_lifetime";
	} else {
		k = k + "_intro";
	}
	
	$("l_" + item).title = titles[k]
}

function setTitles()
{
	setTitle("bends");
	setTitle("situps");
	setTitle("leglifts");
	setTitle("pushups");
	setTitle("sets");
	setTitle("steps");
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
	loadPrefs();
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = $("front");
    var back = $("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = $("front");
    var back = $("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function clickURL(event)
{
	widget.openURL(urls[event.toElement.id]);
}

function updateCounts(rung)
{
	var row = data[rung];
	
	$("nbends").innerText = row.bends;
	$("nsitups").innerText = row.situps;
	$("nleglifts").innerText = row.leglifts;
	$("npushups").innerText = row.pushups;

	var steps = row.steps % 75;
	var sets = (row.steps - steps) / 75;
	
	$("nsets").innerText = sets;
	$("nsteps").innerText = steps;
}

function rungdelta(delta)
{
	var orung = rung;
	rung = orung + delta;
	if (rung <= 1) {
		rung = 1;
	} else if (rung > data.maxrung) {
		rung = data.maxrung;
	}
	
    $("rung").innerText = "Rung " + rung;
	
	updateCounts(rung);
	
	var tt = $("titletext");
	if (rung <= 15) {
		tt.innerText = "Introductory Ladder";
	} else {
		tt.innerText = "Lifetime Ladder";
	}
	
	setTitles();

	if (delta) {
		setPref("reps-" + orung, reps);
		
		setPref("rung", rung);

		reps = getPref("reps-" + rung);
		if (!reps) {
			reps = 0;
		}

		repdelta(0);
	}
}

function rungminus(event)
{
	rungdelta(-1);
}

function rungplus(event)
{
	rungdelta(1);
}

function repdelta(delta)
{
	var oreps = reps;
	reps = oreps + delta;
	if (reps <= 0) {
		reps = 0;
	}
	
    var rt = $("reps");
	rt.innerText = "Count " + reps;
	
	if (delta) {
		setPref("reps-" + rung, reps);
	}
}

function repminus(event)
{
	repdelta(-1);
}
	
function repplus(event)
{
	repdelta(1);
}

function resethigher(event)
{
	for (var i = rung + 1; i <= data.maxrung; i++) {
		setPref("reps-" + i, 0);
	}
}


function maybeCheckVersion()
{
	var now = new Date();
	var secs = Math.round(now.getTime()/1000);
	var last = getPref("lastchecktime");

	if (last === undefined) {
		last = 0;
	} else {
		last = parseInt(last);
	}
	
	var interval = getPref("checkinterval");

	if (interval === undefined) {
		interval = 86400;
	} else {
		interval = parseInt(interval);
	}
	
	if (secs > (last + interval)) {
		checkVersion(0);
	}
}


function checkVersion(event)
{
	var onloadHandler = function() { xmlLoaded(xmlRequest); };	// The function to call when the feed is loaded; currently calls the XMLHttpRequest load snippet

	// XMLHttpRequest setup code
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.onload = onloadHandler;
	xmlRequest.open("GET", urls.vercheck, true);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.send("");
}


// Called when an XMLHttpRequest loads a feed; works with the XMLHttpRequest setup snippet
function xmlLoaded(xmlRequest) 
{
	if (xmlRequest.status == 200) {
		// Parse and interpret results
		// XML results found in xmlRequest.responseXML
		// Text results found in xmlRequest.reponseText
		x = xmlRequest.responseXML;
		keys = x.getElementsByTagName("item");
		for (var i=0; i < keys.length; i++) {
			var k = keys[i];
			var n = k.getElementsByTagName("category")[0].firstChild.data;
			if (n == "track5bx") {
				var vs = k.getElementsByTagName("title")[0].firstChild.data;
				var url = k.getElementsByTagName("link")[0].firstChild.data;
				var curver = parseInt(vs);

				var now = new Date();
				var secs = Math.round(now.getTime()/1000);
				setPref("lastchecktime", secs);

				if (curver > version) {
					widget.openURL(url + "?ov=" + version + "&nv=" + curver);
					break;
				}
			}			
		}
	} else {
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}


if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


